SystemOrganization addCategory: #'Orca-Widgets'!

Object subclass: #OrcaShape
	instanceVariableNames: 'canvas graphics color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

OrcaShape subclass: #OrcaCircle
	instanceVariableNames: 'position radius'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaCircle methodsFor: 'graphics' stamp: 'ag 4/5/2011 10:27'!
drawOn: aGraphics
	"CTK library: http://canvastoolkit.codeplex.com/"
	
	aGraphics setColor value: self color.
	aGraphics fillCircle
		value: self position x
		value: self position y
		value: self radius.! !

!OrcaCircle methodsFor: 'initialization' stamp: 'LT 2/21/2011 15:30:24.69'!
initialize
	
	super initialize.
	self
		color: '#ff0000';
		radius: 10;
		position: 1@1.! !

!OrcaCircle methodsFor: 'accessing' stamp: 'LT 12/21/2010 18:14:18.683'!
position
	^ position! !

!OrcaCircle methodsFor: 'accessing' stamp: 'LT 12/21/2010 18:14:18.695'!
position: anObject
	position := anObject! !

!OrcaCircle methodsFor: 'accessing' stamp: 'LT 12/21/2010 18:14:18.704'!
radius
	^ radius! !

!OrcaCircle methodsFor: 'accessing' stamp: 'LT 12/21/2010 18:14:18.712'!
radius: anObject
	radius := anObject! !

!OrcaCircle methodsFor: 'graphics' stamp: 'ag 4/5/2011 10:28'!
step
	
	self drawOn: self graphics.! !

!OrcaShape methodsFor: 'accessing' stamp: 'sec 12/22/2010 12:03'!
canvas
	^ canvas! !

!OrcaShape methodsFor: 'accessing' stamp: 'LT 12/21/2010 18:33:58.38'!
canvas: anObject
	canvas := anObject! !

!OrcaShape methodsFor: 'accessing' stamp: 'ag 1/12/2011 10:51'!
color
	^ color! !

!OrcaShape methodsFor: 'accessing' stamp: 'ag 1/12/2011 10:51'!
color: anObject
	color := anObject! !

!OrcaShape methodsFor: 'accessing' stamp: 'ag 4/5/2011 10:27'!
graphics
	^ graphics! !

!OrcaShape methodsFor: 'accessing' stamp: 'ag 4/5/2011 10:27'!
graphics: anObject
	graphics := anObject! !

Object subclass: #OrcaWidget
	instanceVariableNames: 'node children extent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

OrcaWidget subclass: #OrcaAccordion
	instanceVariableNames: 'autoHeight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaAccordion class methodsFor: 'configuration' stamp: 'hk 3/8/2011 09:58'!
defaultCssId

	 ^ 'accordion'! !

!OrcaAccordion class methodsFor: 'configuration' stamp: 'hk 3/8/2011 10:08'!
hasAutoHeight

	^ false! !

!OrcaAccordion methodsFor: 'accessing' stamp: 'ag 4/6/2011 15:52'!
add: aWidget named: aString
	
	| link heading container |
	link := OrcaAnchor named: aString.
	heading := OrcaHeading new add: link; yourself.
	container := (OrcaContainer vertical) add: aWidget.
	self
		add: heading;
		add: container.! !

!OrcaAccordion methodsFor: 'accessing' stamp: 'hk 3/8/2011 10:07'!
autoHeight
	^ autoHeight! !

!OrcaAccordion methodsFor: 'accessing' stamp: 'hk 3/8/2011 10:07'!
autoHeight: anObject
	autoHeight := anObject! !

!OrcaAccordion methodsFor: 'initialization' stamp: 'ag 4/5/2011 17:51'!
enableAccordion
	
	(Js @ ('#', self class defaultCssId)) accordion value: self parameters.! !

!OrcaAccordion methodsFor: 'initialization' stamp: 'hk 3/8/2011 10:08'!
initialize 

	super initialize.
	self autoHeight: self class hasAutoHeight.
	self cssId: self class defaultCssId.! !

!OrcaAccordion methodsFor: 'initialization' stamp: 'hk 3/8/2011 09:49'!
onLoad

	self enableAccordion.
	super onLoad.! !

!OrcaAccordion methodsFor: 'initialization' stamp: 'hk 3/8/2011 10:10'!
parameters

	^ { #autoHeight -> self autoHeight . #navigation -> true } asObject! !

OrcaWidget subclass: #OrcaConfirm
	instanceVariableNames: 'message block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaConfirm class methodsFor: 'configuration' stamp: 'hk 3/21/2011 14:09'!
defaultMessage

	^ 'Are you sure?'! !

!OrcaConfirm methodsFor: 'accessing' stamp: 'hk 3/21/2011 13:27'!
block
	^ block! !

!OrcaConfirm methodsFor: 'accessing' stamp: 'hk 3/21/2011 13:27'!
block: anObject
	block := anObject! !

!OrcaConfirm methodsFor: 'accessing' stamp: 'hk 4/5/2011 14:59'!
confirm

	| isConfirmed |
	isConfirmed := Js Global confirm value: self message.
	isConfirmed ifTrue: [ self block value ].! !

!OrcaConfirm methodsFor: 'accessing' stamp: 'hk 3/21/2011 14:10'!
message
	message ifNil: [ message := self class defaultMessage ].
	^ message! !

!OrcaConfirm methodsFor: 'accessing' stamp: 'hk 3/21/2011 13:27'!
message: anObject
	message := anObject! !

OrcaWidget subclass: #OrcaContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaContainer class methodsFor: 'instance creation' stamp: 'ag 4/6/2011 15:52'!
horizontal

	^ OrcaHorizontalContainer new! !

!OrcaContainer class methodsFor: 'configuration' stamp: 'hk 1/24/2011 10:43'!
htmlElementType

	^ 'div'! !

!OrcaContainer class methodsFor: 'configuration' stamp: 'hk 4/7/2011 13:07'!
start

	OrcaTabHost new
		add: (OrcaTextArea new) named: 'TextArea A';
		add: (OrcaTextArea new) named: 'TextArea B';
		addToWorld.! !

!OrcaContainer class methodsFor: 'instance creation' stamp: 'ag 4/6/2011 15:52'!
vertical

	^ OrcaVerticalContainer new! !

!OrcaContainer methodsFor: 'rendering' stamp: 'hk 3/8/2011 11:20'!
add: element

	super add: element.
	element beRelative! !

OrcaContainer subclass: #OrcaHorizontalContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaHorizontalContainer methodsFor: 'initialization' stamp: 'hk 1/31/2011 15:09'!
initialize
	
	super initialize.
	self cssClass: 'horizontal'.
! !

OrcaContainer subclass: #OrcaVerticalContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaVerticalContainer methodsFor: 'initialization' stamp: 'sw 4/5/2011 13:34'!
initialize
	
	super initialize.
	self cssClass: 'vertical'. ! !

OrcaWidget subclass: #OrcaDialog
	instanceVariableNames: 'paragraph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaDialog class methodsFor: 'configuration' stamp: 'hk 2/28/2011 15:01'!
defaultCssId

	^ 'dialog'! !

!OrcaDialog methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
initialize
	
	super initialize.
	self cssId: self class defaultCssId.
	self paragraph: OrcaParagraph new.
	self add: self paragraph.
! !

!OrcaDialog methodsFor: 'initialization' stamp: 'ag 4/5/2011 17:51'!
initializeDialog

	(Js @ ('#', self class defaultCssId)) dialog
		value: self parameters.! !

!OrcaDialog methodsFor: 'initialization' stamp: 'hk 3/6/2011 22:14'!
onLoad

	self initializeDialog.
	super onLoad.! !

!OrcaDialog methodsFor: 'accessing' stamp: 'hk 2/28/2011 14:59'!
paragraph
	^ paragraph! !

!OrcaDialog methodsFor: 'accessing' stamp: 'hk 2/28/2011 14:59'!
paragraph: anObject
	paragraph := anObject! !

!OrcaDialog methodsFor: 'accessing' stamp: 'LT 4/4/2011 17:17:11.31'!
parameters

	^ { #autoOpen -> true.
		#show -> 'clip'.
		#hide -> 'clip' } asObject
! !

!OrcaDialog methodsFor: 'accessing' stamp: 'hk 2/28/2011 15:00'!
text

	^ self paragraph text! !

!OrcaDialog methodsFor: 'accessing' stamp: 'hk 2/28/2011 15:00'!
text: aString

	self paragraph text: aString.! !

!OrcaDialog methodsFor: 'accessing' stamp: 'LT 4/4/2011 17:25:30.699'!
title
	
	^ self node title! !

!OrcaDialog methodsFor: 'accessing' stamp: 'LT 4/4/2011 17:25:22.373'!
title: aString

	self node title: aString.! !

OrcaWidget subclass: #OrcaImage
	instanceVariableNames: 'source description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaImage class methodsFor: 'configuration' stamp: 'SW 1/31/2011 12:40'!
htmlElementType

	^ 'img'! !

!OrcaImage methodsFor: 'accessing' stamp: 'SW 1/31/2011 12:41'!
description
	^ description! !

!OrcaImage methodsFor: 'accessing' stamp: 'sw 3/29/2011 13:49'!
description: anObject

	description := anObject.
	self node alt: anObject.
	! !

!OrcaImage methodsFor: 'initialization' stamp: 'hk 2/1/2011 12:29'!
initialize 
	
	super initialize.
	self
		source: '';
		description: ''.! !

!OrcaImage methodsFor: 'accessing' stamp: 'SW 1/31/2011 12:41'!
source
	^ source! !

!OrcaImage methodsFor: 'accessing' stamp: 'sw 3/29/2011 13:49'!
source: anObject

	source := anObject.
	self node src: anObject.! !

OrcaWidget subclass: #OrcaInput
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

OrcaInput subclass: #OrcaButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaButton methodsFor: 'initialization' stamp: 'sw 3/29/2011 14:25'!
initialize 
	
	super initialize.
	self node type: 'button'! !

OrcaButton subclass: #OrcajQueryButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcajQueryButton methodsFor: 'initialization' stamp: 'ag 4/5/2011 17:29'!
onLoad
	
	(Js @ 'input:button') button value.! !

!OrcaInput class methodsFor: 'instance creation' stamp: 'LT 2/23/2011 15:38:05.444'!
doing: aBlock withText: aString
	
	^ self new
		onClickDo: aBlock;
		text: aString;
		yourself! !

!OrcaInput class methodsFor: 'configuration' stamp: 'LT 2/23/2011 15:32:03.601'!
htmlElementType
	
	^ 'input'! !

!OrcaInput class methodsFor: 'instance creation' stamp: 'hk 3/28/2011 15:33'!
onClick: aBlock
	
	^ self new onClickDo: aBlock; yourself! !

!OrcaInput methodsFor: 'rendering' stamp: 'sw 3/30/2011 15:00'!
disable
	
	self node disabled: true! !

!OrcaInput methodsFor: 'rendering' stamp: 'sw 3/30/2011 15:00'!
enable
	
	self node disabled: false! !

!OrcaInput methodsFor: 'accessing' stamp: 'LT 4/4/2011 17:30:12.227'!
text
	
	^ self node value
	! !

!OrcaInput methodsFor: 'accessing' stamp: 'sw 3/29/2011 14:27'!
text: aString
	
	self node value: aString
	! !

OrcaWidget subclass: #OrcaListItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaListItem class methodsFor: 'configuration' stamp: 'SW 2/21/2011 14:03'!
htmlElementType

	^ 'li'! !

OrcaListItem subclass: #OrcaTab
	instanceVariableNames: 'associatedWidget'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaTab class methodsFor: 'instance creation' stamp: 'ag 4/6/2011 15:52'!
newFor: aWidget named: aString
	
	^ self new
		associatedWidget: aWidget;
		add: (OrcaAnchor referencing: aWidget named: aString);
		yourself! !

!OrcaTab methodsFor: 'accessing' stamp: 'SW 3/16/2011 11:01'!
associatedWidget
	^ associatedWidget! !

!OrcaTab methodsFor: 'accessing' stamp: 'SW 3/16/2011 11:01'!
associatedWidget: anObject
	associatedWidget := anObject! !

OrcaWidget subclass: #OrcaLoader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaLoader class methodsFor: 'configuration' stamp: 'hk 2/1/2011 15:27'!
defaultImage

	^ 'http://localhost:8887/play/file/images/loader.gif'! !

!OrcaLoader class methodsFor: 'configuration' stamp: 'hk 2/1/2011 12:31'!
htmlElementType

	^ 'div'! !

!OrcaLoader methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
initialize

	| image |
	super initialize.
	
	image := OrcaImage new
		source: self class defaultImage;
	 	description: 'Loading'.
	self cssClass: 'loader'.
	self add: (OrcaParagraph new add: image; yourself).
	self hide.! !

!OrcaLoader methodsFor: 'initialization' stamp: 'sw 3/29/2011 14:51'!
show 

	self node style display: 'table'.! !

OrcaWidget subclass: #OrcaNamedWidget
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaNamedWidget methodsFor: 'accessing' stamp: 'hk 2/1/2011 14:18'!
name
	^ name! !

!OrcaNamedWidget methodsFor: 'accessing' stamp: 'hk 2/1/2011 14:18'!
name: anObject
	name := anObject! !

OrcaNamedWidget subclass: #OrcaRadioButton
	instanceVariableNames: 'caption value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaRadioButton class methodsFor: 'configuration' stamp: 'hk 2/1/2011 10:51'!
htmlElementType

	^ 'input'! !

!OrcaRadioButton class methodsFor: 'instance creation' stamp: 'hk 3/6/2011 22:29'!
withCaption: aCaption andValue: aValue

	^ self new
		caption: aCaption;
		value: aValue;
		cssId: aValue;
		refreshMarkup! !

!OrcaRadioButton methodsFor: 'accessing' stamp: 'hk 2/1/2011 10:54'!
caption
	^ caption! !

!OrcaRadioButton methodsFor: 'accessing' stamp: 'hk 2/1/2011 10:54'!
caption: anObject
	caption := anObject! !

!OrcaRadioButton methodsFor: 'convenience' stamp: 'sw 3/29/2011 15:51'!
check

	self node checked: 'checked'.! !

!OrcaRadioButton methodsFor: 'initialization' stamp: 'sw 3/29/2011 15:51'!
initialize 

	super initialize.
	self node type: 'radio'.! !

!OrcaRadioButton methodsFor: 'convenience' stamp: 'sw 3/29/2011 15:51'!
isChecked

	^ self node checked! !

!OrcaRadioButton methodsFor: 'initialization' stamp: 'sw 3/29/2011 15:52'!
refreshMarkup

	self node value: self value.
	self node name: self name.! !

!OrcaRadioButton methodsFor: 'accessing' stamp: 'hk 2/1/2011 10:56'!
value
	^ value! !

!OrcaRadioButton methodsFor: 'accessing' stamp: 'hk 2/1/2011 10:56'!
value: anObject
	value := anObject! !

OrcaNamedWidget subclass: #OrcaRadioGroup
	instanceVariableNames: 'radioButtons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

OrcaRadioGroup subclass: #OrcaButtonSet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaButtonSet class methodsFor: 'configuration' stamp: 'hk 3/6/2011 22:45'!
defaultCssId

	^ 'buttonSet'! !

!OrcaButtonSet methodsFor: 'initialization' stamp: 'ag 4/5/2011 17:51'!
enableButtonSet
	
	(Js @ ('#', self class defaultCssId)) buttonset value! !

!OrcaButtonSet methodsFor: 'initialization' stamp: 'hk 3/6/2011 22:49'!
initialize

	super initialize.
	self cssId: self class defaultCssId.! !

!OrcaButtonSet methodsFor: 'initialization' stamp: 'hk 4/5/2011 13:24'!
onLoad

	self enableButtonSet.! !

!OrcaRadioGroup class methodsFor: 'configuration' stamp: 'hk 2/1/2011 10:49'!
htmlElementType

	^ 'div'! !

!OrcaRadioGroup class methodsFor: 'instance creation' stamp: 'hk 2/1/2011 11:10'!
newNamed: aName

	^ self new name: aName! !

!OrcaRadioGroup methodsFor: 'rendering' stamp: 'hk 3/9/2011 14:52'!
add: aRadioButton

	self children ifEmpty: [ aRadioButton check ].
	self addLabelFor: aRadioButton.
	aRadioButton
		name: self name;
		refreshMarkup.
	super add: aRadioButton.
	self radioButtons add: aRadioButton.! !

!OrcaRadioGroup methodsFor: 'rendering' stamp: 'ag 4/6/2011 15:52'!
addButtonNamed: aString

	self add: (OrcaRadioButton withCaption: aString andValue: aString).! !

!OrcaRadioGroup methodsFor: 'rendering' stamp: 'ag 4/6/2011 15:52'!
addLabelFor: aRadioButton

	| label |
	label := OrcaLabel for: aRadioButton.
	super add: label.! !

!OrcaRadioGroup methodsFor: 'accessing' stamp: 'LT 4/19/2011 11:30'!
currentSelection

	^ ((Js @ '.radio') find value: ':checked') val value.! !

!OrcaRadioGroup methodsFor: 'initialization' stamp: 'hk 3/9/2011 14:49'!
initialize

	super initialize.
	self cssClass: 'radio'.
	self radioButtons: OrderedCollection new.! !

!OrcaRadioGroup methodsFor: 'rendering' stamp: 'sw 3/29/2011 15:52'!
onChange: aBlock

	self radioButtons do: [ :each | each node onclick: aBlock ].! !

!OrcaRadioGroup methodsFor: 'accessing' stamp: 'hk 3/9/2011 14:48'!
radioButtons
	^ radioButtons! !

!OrcaRadioGroup methodsFor: 'accessing' stamp: 'hk 3/9/2011 14:48'!
radioButtons: anObject
	radioButtons := anObject! !

!OrcaRadioGroup methodsFor: 'accessing' stamp: 'sw 4/4/2011 16:44'!
select: aString

	self radioButtons do: [:each |
		each value = aString 
			ifTrue: [ each check ]
		]! !

OrcaWidget subclass: #OrcaSelectList
	instanceVariableNames: 'options'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaSelectList class methodsFor: 'configuration' stamp: 'lw 1/13/2011 10:38'!
htmlElementType
	^ 'select'! !

!OrcaSelectList methodsFor: 'rendering' stamp: 'ag 1/18/2011 14:36'!
addOption: aString
	
	^ self addOption: aString value: aString onClickDo: []! !

!OrcaSelectList methodsFor: 'rendering' stamp: 'robi 1/17/2011 19:39'!
addOption: aString value: aValueString
	
	^ self addOption: aString value: aValueString defaultSelected: false selected: false! !

!OrcaSelectList methodsFor: 'rendering' stamp: 'ag 4/6/2011 15:52'!
addOption: anOption value: aValue defaultSelected: isDefaultSelected selected: isSelected
	"Just to have the full HTML-Option-API reflected here."
	
	^self add: (OrcaListOption new text: anOption; yourself).! !

!OrcaSelectList methodsFor: 'rendering' stamp: 'sw 3/29/2011 15:48'!
addOption: aString value: anotherString onClickDo: aBlock
	
	| anOption |
	anOption := self addOption: aString value: anotherString defaultSelected: false selected: false.
	anOption node onclick: [aBlock value: aString].
	^anOption! !

!OrcaSelectList methodsFor: 'rendering' stamp: 'LT 1/18/2011 21:13:49.638'!
addString: aString

	^ self addString: aString onClickDo: []! !

!OrcaSelectList methodsFor: 'rendering' stamp: 'sec 2/25/2011 22:29'!
addString: aString onClickDo: aBlock

	^self addOption: aString value: aString onClickDo: aBlock! !

!OrcaSelectList methodsFor: 'rendering' stamp: 'sw 3/29/2011 15:48'!
collapse

	self node size: '1'.
	self node height: '20px'.! !

!OrcaSelectList methodsFor: 'rendering' stamp: 'sw 3/30/2011 17:12'!
currentSelection

	^ self node value! !

!OrcaSelectList methodsFor: 'rendering' stamp: 'ag 4/6/2011 18:03'!
fillWith: anOrderedCollection
	
"	| text |
	text := anArrayString.
	OrcaText new 
		addToWorld;
		text: text;
		position: 10 @ 200."! !

!OrcaSelectList methodsFor: 'initialization' stamp: 'sw 3/30/2011 13:13'!
initialize
	
	super initialize.
	self node size: 2! !

!OrcaSelectList methodsFor: 'initialization' stamp: 'sw 3/29/2011 15:50'!
onChange: aBlock

	self node onchange: aBlock! !

!OrcaSelectList methodsFor: 'accessing' stamp: 'sw 3/29/2011 14:49'!
options

	^ self node getElementsByTagName value: 'option'! !

!OrcaSelectList methodsFor: 'accessing' stamp: 'sw 3/29/2011 14:47'!
select: aString

	self options do: [ :each | (aString = (each text))  ifTrue: [ each selected: true ]]! !

OrcaWidget subclass: #OrcaTabHost
	instanceVariableNames: 'tabs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaTabHost class methodsFor: 'configuration' stamp: 'SW 2/21/2011 11:15'!
defaultCssId

	 ^ 'tabs'! !

!OrcaTabHost methodsFor: 'accessing' stamp: 'ag 4/6/2011 15:52'!
add: aWidget named: aString
	
	self ensureIdOf: aWidget.
	self tabs add: (OrcaTab newFor: aWidget named: aString).
	self add: aWidget.! !

!OrcaTabHost methodsFor: 'accessing' stamp: 'hk 4/5/2011 16:51'!
ensureIdOf: aWidget

	aWidget cssId ifEmpty:
		[ | number |
		number := self children size.
		aWidget cssId: self class defaultCssId, '-', number asString. ]! !

!OrcaTabHost methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
initialize 

	super initialize.
	self tabs: OrcaUnorderedList new.
	self add: self tabs.
	self cssId: self class defaultCssId.
! !

!OrcaTabHost methodsFor: 'initialization' stamp: 'ag 4/6/2011 13:09'!
initializeTabs

	Js Global setTimeout
		value: [ (Js @ ('#', self class defaultCssId)) tabs value ] "Cannot give the tabs function directly, must encapsulate into extra anonymous block."
		value: 500.! !

!OrcaTabHost methodsFor: 'initialization' stamp: 'hk 3/6/2011 22:12'!
onLoad

	self initializeTabs.
	super onLoad.! !

!OrcaTabHost methodsFor: 'accessing' stamp: 'SW 2/21/2011 11:07'!
tabs
	^ tabs! !

!OrcaTabHost methodsFor: 'accessing' stamp: 'SW 2/21/2011 11:07'!
tabs: anObject
	tabs := anObject! !

OrcaWidget subclass: #OrcaTable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaTable class methodsFor: 'configuration' stamp: 'SW 2/8/2011 10:37'!
htmlElementType
	
	^ 'table'! !

!OrcaTable methodsFor: 'accessing' stamp: 'ag 4/6/2011 15:52'!
addRowWith: aString
	self add: (OrcaTableRow new put: aString).
! !

!OrcaTable methodsFor: 'accessing' stamp: 'ag 4/6/2011 15:52'!
addRowWith: aString with: anotherString

	| row |
	row:=(OrcaTableRow new) 
			put: aString;
			put: anotherString.			
		
	self add: row.
! !

OrcaWidget subclass: #OrcaTableRow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaTableRow class methodsFor: 'configuration' stamp: 'SW 2/8/2011 10:40'!
htmlElementType
	
	^ 'tr'! !

!OrcaTableRow methodsFor: 'rendering' stamp: 'ag 4/6/2011 15:52'!
put: aString
	
	self add: (OrcaTableCell new text: aString)! !

OrcaWidget subclass: #OrcaText
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

OrcaText subclass: #OrcaAnchor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaAnchor class methodsFor: 'configuration' stamp: 'SW 2/21/2011 11:41'!
htmlElementType 
	
	^ 'a'! !

!OrcaAnchor class methodsFor: 'instance creation' stamp: 'hk 3/8/2011 09:57'!
named: aName

	^ self new
		text: aName;
		target: '#';
		yourself 
! !

!OrcaAnchor class methodsFor: 'instance creation' stamp: 'SW 2/21/2011 14:16'!
referencing: aTarget named: aName

	^ self new
		text: aName;
		target: aTarget;
		yourself 
! !

!OrcaAnchor methodsFor: 'accessing' stamp: 'ag 4/5/2011 17:51'!
target: aTarget

	aTarget isString 
		ifTrue: [ self node href: aTarget ]
		ifFalse: [ self node href: '#', aTarget cssId ].! !

OrcaText subclass: #OrcaHeading
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaHeading class methodsFor: 'configuration' stamp: 'hk 3/8/2011 09:53'!
htmlElementType

	^ 'h3'! !

OrcaText subclass: #OrcaLabel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaLabel class methodsFor: 'instance creation' stamp: 'hk 3/6/2011 22:26'!
for: aRadioButton

	^ self new
		text: aRadioButton caption;
		htmlFor: aRadioButton! !

!OrcaLabel class methodsFor: 'configuration' stamp: 'hk 2/1/2011 14:31'!
htmlElementType

	^ 'label'! !

!OrcaLabel methodsFor: 'rendering' stamp: 'sw 3/29/2011 14:40'!
htmlFor: aRadioButton

	self node htmlFor: aRadioButton cssId.! !

OrcaText subclass: #OrcaListOption
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaListOption class methodsFor: 'configuration' stamp: 'LT 1/18/2011 22:11:51.562'!
htmlElementType
	^'option'! !

!OrcaListOption methodsFor: 'initialization' stamp: 'sw 3/29/2011 15:41'!
initialize

"	self node: (Option jsNew : { ''. ''. false. false })."
	super initialize ! !

!OrcaListOption methodsFor: 'rendering' stamp: 'sw 3/29/2011 15:25'!
text: aString
	
	self node innerHTML: aString.
	self node value: aString.
	^self! !

OrcaText subclass: #OrcaParagraph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaParagraph class methodsFor: 'configuration' stamp: 'hk 2/1/2011 15:41'!
htmlElementType
	
	^ 'p'! !

OrcaText subclass: #OrcaTableCell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaTableCell class methodsFor: 'configuration' stamp: 'SW 2/8/2011 10:40'!
htmlElementType
	
	^ 'td'! !

!OrcaText class methodsFor: 'configuration' stamp: 'sw 4/7/2011 14:18'!
htmlElementType 

	^ 'span'! !

!OrcaText methodsFor: 'rendering' stamp: 'hk 2/28/2011 15:40'!
clear

	super clear.
	self text: ''! !

!OrcaText methodsFor: 'initialization' stamp: 'hk 4/4/2011 10:25'!
initialize
	
	super initialize.
	self text: ''.! !

!OrcaText methodsFor: 'accessing' stamp: 'sw 3/29/2011 14:39'!
text

	^ self node value! !

!OrcaText methodsFor: 'accessing' stamp: 'hk 4/4/2011 15:13'!
text: aString
	
	self node innerHTML: aString.
	self node value: aString.! !

OrcaText subclass: #OrcaTextArea
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

OrcaTextArea subclass: #OrcaTabbyTextArea
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaTabbyTextArea class methodsFor: 'configuration' stamp: 'hk 4/4/2011 16:44'!
scriptSource

	^ 'http://teddevito.com/demos/js/jquery.textarea.js'! !

!OrcaTabbyTextArea methodsFor: 'initialization' stamp: 'hk 4/4/2011 16:45'!
initialize

	| script |
	super initialize.
	script := Js Document createElement value: 'script'.
	script
		src: self class scriptSource;
		type: 'text/javascript'.
	self node appendChild value: script.! !

!OrcaTabbyTextArea methodsFor: 'initialization' stamp: 'ag 4/5/2011 17:51'!
onLoad
	
	self withDisposableId: [ (Js @ ('#', self cssId)) tabby value ].! !

!OrcaTextArea class methodsFor: 'configuration' stamp: 'robi 1/17/2011 19:41'!
htmlElementType
	
	^ 'textarea'! !

!OrcaTextArea class methodsFor: 'instance creation' stamp: 'hk 1/26/2011 11:26'!
with: aString

	^ self new text: aString; yourself! !

!OrcaTextArea methodsFor: 'rendering' stamp: 'hk 4/4/2011 15:12'!
beReadOnly

	self node setAttribute value: 'readonly' value: 'readonly'.! !

OrcaWidget subclass: #OrcaUnorderedList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaUnorderedList class methodsFor: 'configuration' stamp: 'SW 2/21/2011 11:32'!
htmlElementType 

	^ 'ul'! !

!OrcaWidget class methodsFor: 'configuration' stamp: 'SW 2/7/2011 14:46'!
htmlElementType
	
	^ 'div'! !

!OrcaWidget class methodsFor: 'configuration' stamp: 'robi 1/26/2011 12:00'!
start
	" this method will only be invoked in case you use your widget as a start app"
	^ self new addToWorld! !

!OrcaWidget methodsFor: 'rendering' stamp: 'hk 3/30/2011 11:30'!
add: anObject

	self children add: anObject.
	self node appendChild value: anObject node.
	^ anObject! !

!OrcaWidget methodsFor: 'rendering' stamp: 'sec 1/25/2011 15:18'!
addAll: aCollection

	aCollection do: [ :each | self add: each ].! !

!OrcaWidget methodsFor: 'rendering' stamp: 'sw 3/29/2011 17:11'!
addToWorld
	"Add this widget to a root-div-element."
		
	(Js Document getElementById value: 'container')
		appendChild value: self node.
	self onLoad.! !

!OrcaWidget methodsFor: 'rendering' stamp: 'sw 3/29/2011 14:33'!
beRelative

	self node style position: 'relative'.
	self node style top: '0'.
	self node style left: '0'! !

!OrcaWidget methodsFor: 'accessing' stamp: 'LT 1/18/2011 21:53:58.821'!
children
	^ children! !

!OrcaWidget methodsFor: 'accessing' stamp: 'LT 1/18/2011 21:53:58.832'!
children: anObject
	children := anObject! !

!OrcaWidget methodsFor: 'rendering' stamp: 'sw 3/31/2011 14:51'!
clear
	
	self children do: [ :each | self node removeChild value:  (each node ) ].
	self children removeAll.! !

!OrcaWidget methodsFor: 'rendering' stamp: 'sw 3/29/2011 14:14'!
cssClass: aString

	self node className: aString! !

!OrcaWidget methodsFor: 'rendering' stamp: 'sw 3/29/2011 13:51'!
cssId

	^ self node id
	! !

!OrcaWidget methodsFor: 'rendering' stamp: 'sw 3/30/2011 13:07'!
cssId: aString

	self node id: aString! !

!OrcaWidget methodsFor: 'accessing' stamp: 'sw 3/29/2011 14:29'!
extent
	
	^ Point x: (self node width) y: (self node height)! !

!OrcaWidget methodsFor: 'accessing' stamp: 'sw 3/29/2011 14:32'!
extent: anObject
	
	extent := anObject.
	self node style height: anObject y asString , 'px'. 
	self node style width: anObject x asString , 'px'! !

!OrcaWidget methodsFor: 'convenience' stamp: 'hk 4/5/2011 12:52'!
generateCssId

	self clientSideResposibility.! !

!OrcaWidget methodsFor: 'rendering' stamp: 'sw 3/29/2011 14:36'!
height: aHeight
	
	self node style height: aHeight.! !

!OrcaWidget methodsFor: 'accessing' stamp: 'sw 3/29/2011 14:23'!
hide 

	self node style display: 'none'! !

!OrcaWidget methodsFor: 'initialization' stamp: 'sw 3/29/2011 14:11'!
initialize
	
	self
		node: (Js Document createElement value: self class htmlElementType);
		children: OrderedCollection new.! !

!OrcaWidget methodsFor: 'rendering' stamp: 'sw 3/29/2011 14:37'!
marginBottom: aHeight
	
	self node style marginBottom: aHeight asString, 'px'! !

!OrcaWidget methodsFor: 'rendering' stamp: 'sw 3/29/2011 14:37'!
marginTop: aHeight
	
	self node style marginTop: aHeight asString, 'px'! !

!OrcaWidget methodsFor: 'accessing' stamp: 'lw 1/13/2011 10:35'!
node
	^ node! !

!OrcaWidget methodsFor: 'accessing' stamp: 'ag 1/18/2011 09:45'!
node: anObject
	"Must not be set after initialization"
	
	node := anObject! !

!OrcaWidget methodsFor: 'convenience' stamp: 'sw 4/7/2011 15:16'!
onClickDo: aBlockClosure

	self node onclick: aBlockClosure.! !

!OrcaWidget methodsFor: 'initialization' stamp: 'hk 4/5/2011 13:21'!
onLoad

	self children ifNil: [ ^ self ].
	self children do: [ :each | each onLoad ].! !

!OrcaWidget methodsFor: 'accessing' stamp: 'hk 2/1/2011 11:31'!
pathFor: aFile

	^ self app uniquePath, '/', aFile! !

!OrcaWidget methodsFor: 'accessing' stamp: 'sw 3/29/2011 14:38'!
position: anObject
	
	self node style position: 'absolute'.
	self node style top: anObject y asString, 'px'.
	self node style left: anObject x asString , 'px'.! !

!OrcaWidget methodsFor: 'accessing' stamp: 'sw 3/29/2011 14:38'!
show 

	self node style display: 'block'.! !

!OrcaWidget methodsFor: 'rendering' stamp: 'sw 3/29/2011 14:38'!
width: aWidth
	
	self node style width: aWidth.! !

!OrcaWidget methodsFor: 'convenience' stamp: 'hk 4/5/2011 10:53'!
withDisposableId: aBlock

	| oldId |
	oldId := self cssId.
	self cssId: self generateCssId.
	aBlock value.
	self cssId: oldId.! !

OrcaWidget subclass: #OrcaWindow
	instanceVariableNames: 'title content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OrcaWindow class methodsFor: 'configuration' stamp: 'hk 3/7/2011 15:30'!
defaultCssClasses

	^ 'ui-dialog ui-widget ui-widget-content ui-corner-all ui-draggable'! !

!OrcaWindow class methodsFor: 'configuration' stamp: 'hk 3/4/2011 12:55'!
defaultCssId

	^ 'window'! !

!OrcaWindow class methodsFor: 'configuration' stamp: 'hk 3/4/2011 13:16'!
defaultEffect

	^ 'blind'! !

!OrcaWindow class methodsFor: 'instance creation' stamp: 'hk 3/4/2011 11:57'!
newTitled: aString

	^ self basicNew title: aString; initialize! !

!OrcaWindow methodsFor: 'rendering' stamp: 'hk 3/8/2011 11:12'!
add: aWidget

	self content add: aWidget.! !

!OrcaWindow methodsFor: 'accessing' stamp: 'hk 3/4/2011 13:19'!
content
	^ content! !

!OrcaWindow methodsFor: 'accessing' stamp: 'hk 3/4/2011 13:19'!
content: anObject
	content := anObject! !

!OrcaWindow methodsFor: 'initialization' stamp: 'sw 4/6/2011 08:45'!
initialize

	super initialize.
	self
		cssClass: self class defaultCssClasses;
		cssId: self class defaultCssId;
		width: 'auto'.
	self
		initializeContentArea;
		initializeTitleBar.
! !

!OrcaWindow methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
initializeContentArea

	self content: (OrcaText new cssClass: 'ui-widget-content'; yourself).
	super add: self content.! !

!OrcaWindow methodsFor: 'initialization' stamp: 'ag 4/6/2011 15:52'!
initializeTitleBar

	| titleBar |
	titleBar := OrcaText new
		text: self title;
		cssClass: 'ui-dialog-titlebar ui-widget-header ui-corner-all ui-helper-clearfix'.
	titleBar add: ((OrcaButton doing: [ self toggle ] withText: 'toggle') cssClass: 'ui-icon ui-icon-triangle-2-n-s').
	self add: titleBar! !

!OrcaWindow methodsFor: 'initialization' stamp: 'ag 4/5/2011 17:51'!
makeDraggable

	(Js @ ('#',  self class defaultCssId)) draggable value! !

!OrcaWindow methodsFor: 'initialization' stamp: 'hk 4/5/2011 13:23'!
onLoad

	self makeDraggable.
	self content onLoad.! !

!OrcaWindow methodsFor: 'accessing' stamp: 'hk 3/4/2011 11:49'!
title
	^ title! !

!OrcaWindow methodsFor: 'accessing' stamp: 'hk 3/4/2011 11:49'!
title: anObject
	title := anObject! !

!OrcaWindow methodsFor: 'animation' stamp: 'ag 4/5/2011 17:39'!
toggle
	
	(Js @ '#window .ui-widget-content') toggle
		value: self class defaultEffect
		value: {} asObject
		value: 500.! !
